#ifndef MSP_GRAPHICS_SIMPLEWINDOW_H_
#define MSP_GRAPHICS_SIMPLEWINDOW_H_

#include "display.h"
#include "glcontext.h"
#include "window.h"

namespace Msp {
namespace Graphics {

/**
Helper class for SimpleWindow.
*/
class SimpleWindowBase
{
protected:
	Display dpy;

	SimpleWindowBase() { }
};


/**
A simplified Window that encapsulates a Display.
*/
class SimpleWindow: public SimpleWindowBase, public Window
{
public:
	SimpleWindow(unsigned, unsigned, bool =false);

	void tick();
};


/**
A SimpleWindow bundled with a GLContext.
*/
class SimpleGLWindow: public SimpleWindow
{
private:
	GLContext gl_ctx;

public:
	SimpleGLWindow(unsigned, unsigned, bool =false);
	GLContext &get_gl_context() { return gl_ctx; }
	void swap_buffers();
};

} // namespace Graphics
} // namespace Msp

#endif
